data modify entity @s Sitting set value 0b
data modify entity @s Sleeping set value 0b
data modify entity @s Rotation[0] set from entity @p[scores={riding=1}] Rotation[0]

# -----
# small
# -----

# ride
execute if entity @s[type=#hitbox_small] if block ^ ^0.85 ^1 #air_like if block ^0.425 ^0.85 ^0.8 #bamboo_air_like if block ^-0.425 ^0.85 ^0.8 #bamboo_air_like if entity @s[nbt={OnGround:1b}] run tp @s ^ ^ ^0.6
execute if entity @s[type=#hitbox_small] if block ^ ^0.15 ^0.25 minecraft:ladder if block ^ ^1 ^0.25 #air_like if block ^0.15 ^1.75 ^0.25 #air_like if block ^-0.15 ^1.75 ^0.25 #air_like run tp @s ^ ^0.2 ^
# jump
execute if entity @s[type=#hitbox_small] if block ^ ^1.30 ^1 #air_like if block ^0.425 ^1.30 ^0.8 #bamboo_air_like if block ^-0.425 ^1.30 ^0.8 #bamboo_air_like unless block ^ ^0.15 ^1 #non_solid run tp @s ^ ^1.3 ^0.6
execute if entity @s[type=#hitbox_small] unless block ~ ~ ~ #slabs_like if block ^0.425 ^1.30 ^0.8 #bamboo_air_like if block ^-0.425 ^1.30 ^0.8 #bamboo_air_like if block ^ ^0.15 ^1 #slabs_like if block ^ ^1.30 ^1 #air_like run tp @s ^ ^0.6 ^0.6
execute if entity @s[type=#hitbox_small] if block ~ ~ ~ #path_like if block ^ ^0.5 ^1 #air_like if block ^0.425 ^0.5 ^1 #bamboo_air_like if block ^-0.425 ^0.5 ^1 #bamboo_air_like if block ^ ^ ^1 #non_solid unless block ^ ^ ^1 #path_like run tp @s ^ ^0.2 ^0.6
execute if entity @s[type=#hitbox_small] if block ^ ^-0.10 ^0.25 minecraft:ladder if block ^ ^0.1 ^1 #air_like if block ^ ^1.50 ^1 #air_like run tp @s ^ ^0.2 ^0.5

# ------
# medium
# ------

# ride
execute if entity @s[type=!#hitbox_big, type=!#hitbox_small, type=!sniffer] if block ^ ^0.85 ^1.25 #air_like if block ^0.6 ^0.85 ^0.9 #bamboo_air_like if block ^-0.6 ^0.85 ^0.9 #bamboo_air_like if block ^ ^1.30 ^1.25 #air_like if block ^0.6 ^1.30 ^0.9 #bamboo_air_like if block ^-0.6 ^1.30 ^0.9 #bamboo_air_like if entity @s[nbt={OnGround:1b}] run tp @s ^ ^ ^0.7
execute if entity @s[type=!#hitbox_big, type=!#hitbox_small, type=!sniffer] if block ^ ^0.15 ^0.3 minecraft:ladder if block ^ ^1.8 ^0.3 #air_like if block ^0.4 ^1.8 ^0.3 #air_like if block ^-0.4 ^1.8 ^0.3 #air_like run tp @s ^ ^0.2 ^
# jump
execute if entity @s[type=!#hitbox_big, type=!#hitbox_small, type=!sniffer] if block ^ ^1.30 ^1.5 #air_like if block ^0.6 ^1.30 ^0.9 #bamboo_air_like if block ^-0.6 ^1.30 ^0.9 #bamboo_air_like unless block ^ ^0.15 ^1.5 #non_solid run tp @s ^ ^1.3 ^0.6
execute if entity @s[type=!#hitbox_big, type=!#hitbox_small, type=!sniffer] unless block ~ ~ ~ #slabs_like if block ^0.6 ^1.30 ^0.9 #bamboo_air_like if block ^-0.6 ^1.30 ^0.9 #bamboo_air_like if block ^ ^0.15 ^1.5 #slabs_like if block ^ ^1.30 ^1.5 #air_like run tp @s ^ ^0.6 ^0.6
execute if entity @s[type=!#hitbox_big, type=!#hitbox_small, type=!sniffer] if block ~ ~ ~ #path_like if block ^ ^0.5 ^1 #air_like if block ^0.6 ^0.5 ^1 #bamboo_air_like if block ^-0.6 ^0.5 ^1 #bamboo_air_like if block ^ ^ ^1 #non_solid unless block ^ ^ ^1 #path_like run tp @s ^ ^0.2 ^0.6
execute if entity @s[type=!#hitbox_big, type=!#hitbox_small, type=!sniffer] if block ^ ^-0.10 ^0.3 minecraft:ladder if block ^ ^0.1 ^1.25 #air_like if block ^ ^1.60 ^1.25 #air_like run tp @s ^ ^0.2 ^0.5

# ---
# big
# ---

# ride
execute if entity @s[type=#hitbox_big] if block ^ ^0.85 ^1.5 #air_like if block ^1.00 ^0.85 ^1.3 #bamboo_air_like if block ^-1.00 ^0.85 ^1.3 #bamboo_air_like if block ^ ^1.30 ^1.5 #air_like if block ^1.00 ^1.30 ^1.3 #bamboo_air_like if block ^-1.00 ^1.30 ^1.3 #bamboo_air_like if entity @s[nbt={OnGround:1b}] run tp @s ^ ^ ^0.55
execute if entity @s[type=#hitbox_big] if block ^ ^0.15 ^1 minecraft:ladder if block ^ ^1.75 ^1 #air_like if block ^1.15 ^1.75 ^1 #air_like if block ^-1.15 ^1.75 ^1 #air_like run tp @s ^ ^0.2 ^
# jump
execute if entity @s[type=#hitbox_big] if block ^ ^1.30 ^1.5 #air_like if block ^1.00 ^1.30 ^1.3 #bamboo_air_like if block ^-1.00 ^1.30 ^1.3 #bamboo_air_like unless block ^ ^0.15 ^1.5 #non_solid run tp @s ^ ^1.5 ^0.6
execute if entity @s[type=#hitbox_big] unless block ~ ~ ~ #slabs_like if block ^1.00 ^1.30 ^1.3 #bamboo_air_like if block ^-1.00 ^1.30 ^1.3 #bamboo_air_like if block ^ ^0.15 ^1.5 #slabs_like if block ^ ^1.30 ^1.5 #air_like run tp @s ^ ^0.6 ^0.6
execute if entity @s[type=#hitbox_big] if block ~ ~ ~ #path_like if block ^ ^0.5 ^1 #air_like if block ^1 ^0.5 ^1 #bamboo_air_like if block ^-1 ^0.5 ^1 #bamboo_air_like if block ^ ^ ^1 #non_solid unless block ^ ^ ^1 #path_like run tp @s ^ ^0.2 ^0.6
execute if entity @s[type=#hitbox_big] if block ^ ^-0.10 ^1 minecraft:ladder if block ^ ^0.1 ^1.75 #air_like if block ^ ^2.20 ^1.75 #air_like run tp @s ^ ^0.2 ^0.5

# -------
# sniffer
# -------

# ride
execute if entity @s[type=sniffer] if block ^ ^0.85 ^2.5 #air_like if block ^1.35 ^0.85 ^1.75 #bamboo_air_like if block ^-1.35 ^0.85 ^1.75 #bamboo_air_like if block ^ ^1.30 ^2.5 #air_like if block ^1.35 ^1.30 ^1.75 #bamboo_air_like if block ^-1.35 ^1.30 ^1.75 #bamboo_air_like if entity @s[nbt={OnGround:1b}] run tp @s ^ ^ ^0.35
# jump
execute if entity @s[type=sniffer] if block ^ ^1.30 ^1.8 #air_like if block ^1 ^1.30 ^1.5 #bamboo_air_like if block ^-1 ^1.30 ^1.5 #bamboo_air_like unless block ^ ^0.15 ^2 #non_solid run tp @s ^ ^1.3 ^0.6
execute if entity @s[type=sniffer] unless block ~ ~ ~ #slabs_like if block ^ ^1.30 ^1.5 #air_like if block ^1 ^1.30 ^1.5 #bamboo_air_like if block ^-1 ^1.30 ^2 #bamboo_air_like if block ^ ^0.15 ^2 #slabs_like run tp @s ^ ^0.6 ^0.6
execute if entity @s[type=sniffer] if block ~ ~ ~ #path_like if block ^ ^0.5 ^1 #air_like if block ^1 ^0.5 ^1 #bamboo_air_like if block ^-1 ^0.5 ^1 #bamboo_air_like if block ^ ^ ^1 #non_solid unless block ^ ^ ^1 #path_like run tp @s ^ ^0.2 ^0.6